'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

exports.default = apolloPassportConnect;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _invariant = require('invariant');

var _invariant2 = _interopRequireDefault(_invariant);

var _client = require('apollo-passportjs/lib/client');

var _client2 = _interopRequireDefault(_client);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function getDisplayName(WrappedComponent) {
  return WrappedComponent.displayName || WrappedComponent.name || 'Component';
}

function apolloPassportConnect(mapStateToProps) {

  return function wrapWithApolloPassportConnect(ComponentToWrap) {

    var connectDisplayName = 'ApolloPassportConnect(' + getDisplayName(ComponentToWrap) + ')';

    var ApolloPassportConnect = function (_Component) {
      _inherits(ApolloPassportConnect, _Component);

      function ApolloPassportConnect(props, context) {
        _classCallCheck(this, ApolloPassportConnect);

        var _this = _possibleConstructorReturn(this, (ApolloPassportConnect.__proto__ || Object.getPrototypeOf(ApolloPassportConnect)).call(this, props, context));

        var apolloPassport = _this.apolloPassport = context.apolloPassport || props.apolloPassport;

        /*
        invariant(apolloPassport,
          `Could not find "apolloPassport" in either the context or ` +
          `props of "${connectDisplayName}". ` +
          `Either wrap the root component in an <ApolloPassportProvider>, ` +
          `or explicitly pass "apolloPassport" as a prop to "${connectDisplayName}".`
        )
        */

        if (!apolloPassport) {
          // TODO this can happen with SSR, need to think about this more
          // i.e. can we show the login state?
          _this.state = {
            auth: {
              data: {}
            }
          };

          _this.actions = {};
          _this.apolloPassport = {};

          return _possibleConstructorReturn(_this);
        }

        _this.state = { auth: apolloPassport.getState(), apolloPassport: apolloPassport };
        apolloPassport.subscribe(function (auth) {
          return _this.setState({ auth: auth, apolloPassport: apolloPassport });
        });
        return _this;
      }

      _createClass(ApolloPassportConnect, [{
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
          this.apolloPassport.unsubscribe(this.setState);
        }
      }, {
        key: 'render',
        value: function render() {
          var mapped = mapStateToProps ? mapStateToProps(this.state) : this.state;

          return _react2.default.createElement(ComponentToWrap, _extends({}, this.props, mapped));
        }
      }]);

      return ApolloPassportConnect;
    }(_react.Component);

    ApolloPassportConnect.displayName = connectDisplayName;
    ApolloPassportConnect.WrappedComponent = ComponentToWrap;

    ApolloPassportConnect.propTypes = {
      apolloPassport: _react.PropTypes.instanceOf(_client2.default)
    };

    ApolloPassportConnect.contextTypes = {
      apolloPassport: _react.PropTypes.instanceOf(_client2.default)
    };

    return ApolloPassportConnect;
  };
}