'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.LoginButtons = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _local = require('./local');

var _local2 = _interopRequireDefault(_local);

var _connect = require('./connect');

var _connect2 = _interopRequireDefault(_connect);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function bindValues(obj, that) {
  var out = {};
  for (var key in obj) {
    out[key] = obj[key].bind(that);
  }return out;
}

var LoginButtonsUI = function LoginButtonsUI(_ref) {
  var auth = _ref.auth,
      showPopup = _ref.showPopup,
      actions = _ref.actions,
      apolloPassport = _ref.apolloPassport;
  return _react2.default.createElement(
    'div',
    { id: 'login-buttons', className: 'login-buttons-dropdown-align-left' },
    _react2.default.createElement(
      'div',
      { className: 'login-link-and-dropdown-list login-form-sign-in' },
      showPopup ? _react2.default.createElement(
        'div',
        { id: 'login-dropdown-list', className: 'accounts-dialog' },
        _react2.default.createElement(
          'a',
          { className: 'login-close-text', onClick: actions.close },
          'Close'
        ),
        _react2.default.createElement('div', { className: 'login-close-text-clear' }),
        auth.data.userId ? showPopup === 'changePass' ? _react2.default.createElement(_local2.default.LoggedInOptions, { auth: auth, apolloPassport: apolloPassport, actions: actions }) : [_react2.default.createElement(_local2.default.LoggedInButtons, { onClick: actions.showPopupChangePass, actions: actions, key: '0'
        }), _react2.default.createElement(
          'div',
          { className: 'login-button', id: 'login-buttons-logout', onClick: actions.logout, key: '1'
          },
          'Sign out'
        )] : [apolloPassport.discovered.services ? apolloPassport.discovered.services.map(function (service, index) {
          return _react2.default.createElement(
            'div',
            { key: service.name, className: 'login-text-and-button' },
            _react2.default.createElement(
              'div',
              { className: 'login-button single-login-button ', id: "login-buttons-" + service.name, onClick: service.open },
              _react2.default.createElement('div', { className: 'login-image', style: { backgroundImage: service.iconUrl }, id: "login-buttons-image-" + service.name }),
              _react2.default.createElement(
                'span',
                { className: "text-besides-image sign-in-text-" + service.name },
                'Sign in with ',
                service.label
              )
            )
          );
        }, this) : null, apolloPassport.discovered.services && true /* local */ ? _react2.default.createElement(
          'div',
          { key: 'or', className: 'or' },
          _react2.default.createElement(
            'span',
            { className: 'hline' },
            '\xA0\xA0\xA0\xA0\xA0\xA0\xA0\xA0\xA0\xA0'
          ),
          _react2.default.createElement(
            'span',
            { className: 'or-text' },
            'or'
          ),
          _react2.default.createElement(
            'span',
            { className: 'hline' },
            '\xA0\xA0\xA0\xA0\xA0\xA0\xA0\xA0\xA0\xA0'
          )
        ) : null, _react2.default.createElement(_local2.default.SignIn, { key: 'local', auth: auth, apolloPassport: apolloPassport, actions: actions })]
      ) : auth.data.userId ? _react2.default.createElement(
        'div',
        { onClick: actions.open },
        auth.data.displayName || auth.data.userId,
        ' \u25BE'
      ) : _react2.default.createElement(
        'a',
        { className: 'login-link-text', onClick: actions.open },
        'Sign in \u25BE'
      )
    )
  );
};
LoginButtonsUI.propTypes = {
  auth: _react.PropTypes.object.isRequired,
  showPopup: _react.PropTypes.oneOfType([_react.PropTypes.bool, _react.PropTypes.string]),
  actions: _react.PropTypes.object.isRequired,
  apolloPassport: _react.PropTypes.object.isRequired
};

var actions = {
  open: function open() {
    this.setState({ showPopup: true });
  },
  close: function close() {
    this.setState({ showPopup: false });
  },
  logout: function logout() {
    this.apolloPassport.logout();
    this.actions.close();
  }
};

function showPopup(state) {
  return function () {
    this.setState({ showPopup: state });
  };
}

actions.showPopupChangePass = showPopup('changePass');

var LoginButtonsController = function (_Component) {
  _inherits(LoginButtonsController, _Component);

  function LoginButtonsController(_ref2) {
    var apolloPassport = _ref2.apolloPassport;

    _classCallCheck(this, LoginButtonsController);

    var _this = _possibleConstructorReturn(this, (LoginButtonsController.__proto__ || Object.getPrototypeOf(LoginButtonsController)).call(this));

    _this.state = { showPopup: false };

    if (!apolloPassport) {
      // TODO this can happen with SSR, need to think about this more
      _this.actions = {};
      _this.apolloPassport = {};
      return _possibleConstructorReturn(_this);
    }

    _this.actions = bindValues(actions, _this);
    _this.apolloPassport = apolloPassport;
    return _this;
  }

  _createClass(LoginButtonsController, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      if (nextProps.auth.data.userId && !this.props.auth.data.userId) this.setState({ showPopup: false });
    }
  }, {
    key: 'render',
    value: function render() {
      return _react2.default.createElement(LoginButtonsUI, _extends({}, this.state, this.props, { actions: this.actions }));
    }
  }]);

  return LoginButtonsController;
}(_react.Component);

LoginButtonsController.propTypes = {
  auth: _react.PropTypes.object.isRequired,
  apolloPassport: _react.PropTypes.object.isRequired
};

var LoginButtonsData = (0, _connect2.default)()(LoginButtonsController);

exports.LoginButtons = LoginButtonsData;